// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtbluetooth_python.h"

// main header
#include "qbluetooth_wrapper.h"

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {

static const char *Sbk_QBluetooth_PropertyStrings[] = {
    nullptr // Sentinel
};

static const char *Sbk_QBluetooth_EnumFlagInfo[] = {
    "AttAccessConstraint:Flag:AttAccessConstraints",
    "Security:Flag:SecurityFlags",
    nullptr // Sentinel
};

static PyMethodDef Sbk_QBluetooth_methods[] = {
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QBluetooth_traverse(PyObject *self, visitproc visit, void *arg)
{
    return SbkObject_TypeF()->tp_traverse(self, visit, arg);
}
static int Sbk_QBluetooth_clear(PyObject *self)
{
    return reinterpret_cast<PyTypeObject *>(SbkObject_TypeF())->tp_clear(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QBluetooth_Type = nullptr;
static PyTypeObject *Sbk_QBluetooth_TypeF(void)
{
    return _Sbk_QBluetooth_Type;
}

static PyType_Slot Sbk_QBluetooth_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(Sbk_object_dealloc /* PYSIDE-832: Prevent replacement of "0" with subtype_dealloc. */)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QBluetooth_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QBluetooth_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QBluetooth_methods)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QBluetooth_spec = {
    "2:PySide6.QtBluetooth.QBluetooth",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QBluetooth_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ enum conversion.
static void QBluetooth_Security_PythonToCpp_QBluetooth_Security(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QBluetooth::Security>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QBluetooth::Security *>(cppOut) = value;

}
static PythonToCppFunc is_QBluetooth_Security_PythonToCpp_QBluetooth_Security_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTH_SECURITY_IDX]))
        return QBluetooth_Security_PythonToCpp_QBluetooth_Security;
    return {};
}
static PyObject *QBluetooth_Security_CppToPython_QBluetooth_Security(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QBluetooth::Security *>(cppIn));
    return Shiboken::Enum::newItem(SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTH_SECURITY_IDX], castCppIn);

}

static void QBluetooth_AttAccessConstraint_PythonToCpp_QBluetooth_AttAccessConstraint(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QBluetooth::AttAccessConstraint>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QBluetooth::AttAccessConstraint *>(cppOut) = value;

}
static PythonToCppFunc is_QBluetooth_AttAccessConstraint_PythonToCpp_QBluetooth_AttAccessConstraint_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTH_ATTACCESSCONSTRAINT_IDX]))
        return QBluetooth_AttAccessConstraint_PythonToCpp_QBluetooth_AttAccessConstraint;
    return {};
}
static PyObject *QBluetooth_AttAccessConstraint_CppToPython_QBluetooth_AttAccessConstraint(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QBluetooth::AttAccessConstraint *>(cppIn));
    return Shiboken::Enum::newItem(SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTH_ATTACCESSCONSTRAINT_IDX], castCppIn);

}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QtBluetoothQBluetooth_SignatureStrings[] = {
    nullptr}; // Sentinel

void init_QtBluetoothQBluetooth(PyObject *module)
{
    _Sbk_QBluetooth_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QBluetooth",
        "QBluetooth",
        &Sbk_QBluetooth_spec,
        nullptr,
        nullptr,
        0,
        0);
    auto *pyType = Sbk_QBluetooth_TypeF(); // references _Sbk_QBluetooth_Type
    InitSignatureStrings(pyType, QtBluetoothQBluetooth_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QBluetooth_PropertyStrings);
    SbkPySide6_QtBluetoothTypes[SBK_QtBluetoothQBLUETOOTH_IDX] = pyType;


    // Pass the ..._EnumFlagInfo to the class.
    SbkObjectType_SetEnumFlagInfo(pyType, Sbk_QBluetooth_EnumFlagInfo);

    // Initialization of enums.
    Shiboken::AutoDecRef tpDict{};
    PyTypeObject *EType{};

    // Initialization of enum 'Security'.
    const char *Security_Initializer[] = {
        "NoSecurity",
        "Authorization",
        "Authentication",
        "Encryption",
        "Secure",
        nullptr};
    // "int8_t" used instead of "int"
    constexpr int8_t Security_InitializerValues[] = {
        int8_t(QBluetooth::Security::NoSecurity),     //  0x00  0
        int8_t(QBluetooth::Security::Authorization),  //  0x01  1
        int8_t(QBluetooth::Security::Authentication), //  0x02  2
        int8_t(QBluetooth::Security::Encryption),     //  0x04  4
        int8_t(QBluetooth::Security::Secure)          //  0x08  8
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QBluetooth_TypeF(),
        "2:PySide6.QtBluetooth.QBluetooth.Security",
        Security_Initializer, Security_InitializerValues);
    SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTH_SECURITY_IDX] = EType;
    // PYSIDE-1735: Mapping the flags class to the same enum class.
    SbkPySide6_QtBluetoothTypes[SBK_QFLAGS_QBLUETOOTH_SECURITY_IDX] =
        EType;
    // Register converter for enum 'QBluetooth::Security'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QBluetooth_Security_CppToPython_QBluetooth_Security);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QBluetooth_Security_PythonToCpp_QBluetooth_Security,
            is_QBluetooth_Security_PythonToCpp_QBluetooth_Security_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QBluetooth::Security");
        Shiboken::Conversions::registerConverterName(converter, "Security");
        // Register converter for flag 'QFlags<QBluetooth::Security>'.
        Shiboken::Conversions::registerConverterName(converter, "QFlags<QBluetooth::Security>");
    }
    // End of 'Security' enum/flags.

    // Initialization of enum 'AttAccessConstraint'.
    const char *AttAccessConstraint_Initializer[] = {
        "AttAuthorizationRequired",
        "AttAuthenticationRequired",
        "AttEncryptionRequired",
        nullptr};
    // "int8_t" used instead of "int"
    constexpr int8_t AttAccessConstraint_InitializerValues[] = {
        int8_t(QBluetooth::AttAccessConstraint::AttAuthorizationRequired),  //  0x01  1
        int8_t(QBluetooth::AttAccessConstraint::AttAuthenticationRequired), //  0x02  2
        int8_t(QBluetooth::AttAccessConstraint::AttEncryptionRequired)      //  0x04  4
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QBluetooth_TypeF(),
        "2:PySide6.QtBluetooth.QBluetooth.AttAccessConstraint",
        AttAccessConstraint_Initializer, AttAccessConstraint_InitializerValues);
    SbkPySide6_QtBluetoothTypes[SBK_QBLUETOOTH_ATTACCESSCONSTRAINT_IDX] = EType;
    // PYSIDE-1735: Mapping the flags class to the same enum class.
    SbkPySide6_QtBluetoothTypes[SBK_QFLAGS_QBLUETOOTH_ATTACCESSCONSTRAINT_IDX] =
        EType;
    // Register converter for enum 'QBluetooth::AttAccessConstraint'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QBluetooth_AttAccessConstraint_CppToPython_QBluetooth_AttAccessConstraint);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QBluetooth_AttAccessConstraint_PythonToCpp_QBluetooth_AttAccessConstraint,
            is_QBluetooth_AttAccessConstraint_PythonToCpp_QBluetooth_AttAccessConstraint_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QBluetooth::AttAccessConstraint");
        Shiboken::Conversions::registerConverterName(converter, "AttAccessConstraint");
        // Register converter for flag 'QFlags<QBluetooth::AttAccessConstraint>'.
        Shiboken::Conversions::registerConverterName(converter, "QFlags<QBluetooth::AttAccessConstraint>");
    }
    // End of 'AttAccessConstraint' enum/flags.

    qRegisterMetaType< ::QBluetooth::Security >("QBluetooth::Security");
    qRegisterMetaType< ::QBluetooth::AttAccessConstraint >("QBluetooth::AttAccessConstraint");
}
