// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QEVENTWRAPPER_H
#define SBK_QEVENTWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <qcoreevent.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QEventWrapper : public QEvent
{
public:
    QEventWrapper(const QEventWrapper &) = delete;
    QEventWrapper& operator=(const QEventWrapper &) = delete;
    QEventWrapper(QEventWrapper &&) = delete;
    QEventWrapper& operator=(QEventWrapper &&) = delete;

    QEventWrapper(::QEvent::Type type);
    QEventWrapper(const QEvent& self) : QEvent(self)
    {
    }

    ::QEvent * clone() const override;
    void setAccepted(bool accepted) override;
    ~QEventWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[2];
};

#endif // SBK_QEVENTWRAPPER_H

