// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only


#ifndef SBK_QTGUI_PYTHON_P_H
#define SBK_QTGUI_PYTHON_P_H

#include <rhi/qrhi.h>
#include <rhi/qshader.h>

class QRhiColorAttachment;
class QRhiDepthStencilClearValue;
struct QRhiGles2InitParams;
struct QRhiGles2NativeHandles;
struct QRhiInitParams;
struct QRhiNativeHandles;
struct QRhiNullInitParams;
class QRhiReadbackDescription;
struct QRhiReadbackResult;
class QRhiRenderPassDescriptor;
class QRhiRenderTarget;
class QRhiResourceUpdateBatch;
class QRhiScissor;
struct QRhiStats;
class QRhiSwapChainRenderTarget;
class QRhiTextureCopyDescription;
class QRhiTextureRenderTargetDescription;
class QRhiTextureSubresourceUploadDescription;
class QRhiTextureUploadDescription;
class QRhiTextureUploadEntry;
class QRhiVertexInputLayout;
class QRhiViewport;
class QShaderCode;
class QShaderKey;
QT_WARNING_PUSH
QT_WARNING_DISABLE_DEPRECATED
namespace Shiboken
{

// PyType functions, to get the PyObjectType for a type T
template<> inline PyTypeObject *SbkType< ::QRhi::Implementation >() { return SbkPySide6_QtGuiTypes[SBK_QRHI_IMPLEMENTATION_IDX]; }
template<> inline PyTypeObject *SbkType< ::QRhi::Flag >() { return SbkPySide6_QtGuiTypes[SBK_QRHI_FLAG_IDX]; }
template<> inline PyTypeObject *SbkType< ::QFlags<QRhi::Flag> >() { return SbkPySide6_QtGuiTypes[SBK_QFLAGS_QRHI_FLAG_IDX]; }
template<> inline PyTypeObject *SbkType< ::QRhi::FrameOpResult >() { return SbkPySide6_QtGuiTypes[SBK_QRHI_FRAMEOPRESULT_IDX]; }
template<> inline PyTypeObject *SbkType< ::QRhi::Feature >() { return SbkPySide6_QtGuiTypes[SBK_QRHI_FEATURE_IDX]; }
template<> inline PyTypeObject *SbkType< ::QRhi::BeginFrameFlag >() { return SbkPySide6_QtGuiTypes[SBK_QRHI_BEGINFRAMEFLAG_IDX]; }
template<> inline PyTypeObject *SbkType< ::QFlags<QRhi::BeginFrameFlag> >() { return SbkPySide6_QtGuiTypes[SBK_QFLAGS_QRHI_BEGINFRAMEFLAG_IDX]; }
template<> inline PyTypeObject *SbkType< ::QRhi::EndFrameFlag >() { return SbkPySide6_QtGuiTypes[SBK_QRHI_ENDFRAMEFLAG_IDX]; }
template<> inline PyTypeObject *SbkType< ::QFlags<QRhi::EndFrameFlag> >() { return SbkPySide6_QtGuiTypes[SBK_QFLAGS_QRHI_ENDFRAMEFLAG_IDX]; }
template<> inline PyTypeObject *SbkType< ::QRhi::ResourceLimit >() { return SbkPySide6_QtGuiTypes[SBK_QRHI_RESOURCELIMIT_IDX]; }
template<> inline PyTypeObject *SbkType< ::QRhi >() { return reinterpret_cast<PyTypeObject *>(SbkPySide6_QtGuiTypes[SBK_QRHI_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiBuffer::Type >() { return SbkPySide6_QtGuiTypes[SBK_QRHIBUFFER_TYPE_IDX]; }
template<> inline PyTypeObject *SbkType< ::QRhiBuffer::UsageFlag >() { return SbkPySide6_QtGuiTypes[SBK_QRHIBUFFER_USAGEFLAG_IDX]; }
template<> inline PyTypeObject *SbkType< ::QFlags<QRhiBuffer::UsageFlag> >() { return SbkPySide6_QtGuiTypes[SBK_QFLAGS_QRHIBUFFER_USAGEFLAG_IDX]; }
template<> inline PyTypeObject *SbkType< ::QRhiBuffer >() { return reinterpret_cast<PyTypeObject *>(SbkPySide6_QtGuiTypes[SBK_QRHIBUFFER_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiColorAttachment >() { return reinterpret_cast<PyTypeObject *>(SbkPySide6_QtGuiTypes[SBK_QRHICOLORATTACHMENT_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiCommandBuffer::IndexFormat >() { return SbkPySide6_QtGuiTypes[SBK_QRHICOMMANDBUFFER_INDEXFORMAT_IDX]; }
template<> inline PyTypeObject *SbkType< ::QRhiCommandBuffer::BeginPassFlag >() { return SbkPySide6_QtGuiTypes[SBK_QRHICOMMANDBUFFER_BEGINPASSFLAG_IDX]; }
template<> inline PyTypeObject *SbkType< ::QFlags<QRhiCommandBuffer::BeginPassFlag> >() { return SbkPySide6_QtGuiTypes[SBK_QFLAGS_QRHICOMMANDBUFFER_BEGINPASSFLAG_IDX]; }
template<> inline PyTypeObject *SbkType< ::QRhiCommandBuffer >() { return reinterpret_cast<PyTypeObject *>(SbkPySide6_QtGuiTypes[SBK_QRHICOMMANDBUFFER_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiComputePipeline::Flag >() { return SbkPySide6_QtGuiTypes[SBK_QRHICOMPUTEPIPELINE_FLAG_IDX]; }
template<> inline PyTypeObject *SbkType< ::QFlags<QRhiComputePipeline::Flag> >() { return SbkPySide6_QtGuiTypes[SBK_QFLAGS_QRHICOMPUTEPIPELINE_FLAG_IDX]; }
template<> inline PyTypeObject *SbkType< ::QRhiComputePipeline >() { return reinterpret_cast<PyTypeObject *>(SbkPySide6_QtGuiTypes[SBK_QRHICOMPUTEPIPELINE_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiDepthStencilClearValue >() { return reinterpret_cast<PyTypeObject *>(SbkPySide6_QtGuiTypes[SBK_QRHIDEPTHSTENCILCLEARVALUE_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiDriverInfo::DeviceType >() { return SbkPySide6_QtGuiTypes[SBK_QRHIDRIVERINFO_DEVICETYPE_IDX]; }
template<> inline PyTypeObject *SbkType< ::QRhiDriverInfo >() { return reinterpret_cast<PyTypeObject *>(SbkPySide6_QtGuiTypes[SBK_QRHIDRIVERINFO_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiGles2InitParams >() { return reinterpret_cast<PyTypeObject *>(SbkPySide6_QtGuiTypes[SBK_QRHIGLES2INITPARAMS_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiGles2NativeHandles >() { return reinterpret_cast<PyTypeObject *>(SbkPySide6_QtGuiTypes[SBK_QRHIGLES2NATIVEHANDLES_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiGraphicsPipeline::Flag >() { return SbkPySide6_QtGuiTypes[SBK_QRHIGRAPHICSPIPELINE_FLAG_IDX]; }
template<> inline PyTypeObject *SbkType< ::QFlags<QRhiGraphicsPipeline::Flag> >() { return SbkPySide6_QtGuiTypes[SBK_QFLAGS_QRHIGRAPHICSPIPELINE_FLAG_IDX]; }
template<> inline PyTypeObject *SbkType< ::QRhiGraphicsPipeline::Topology >() { return SbkPySide6_QtGuiTypes[SBK_QRHIGRAPHICSPIPELINE_TOPOLOGY_IDX]; }
template<> inline PyTypeObject *SbkType< ::QRhiGraphicsPipeline::CullMode >() { return SbkPySide6_QtGuiTypes[SBK_QRHIGRAPHICSPIPELINE_CULLMODE_IDX]; }
template<> inline PyTypeObject *SbkType< ::QRhiGraphicsPipeline::FrontFace >() { return SbkPySide6_QtGuiTypes[SBK_QRHIGRAPHICSPIPELINE_FRONTFACE_IDX]; }
template<> inline PyTypeObject *SbkType< ::QRhiGraphicsPipeline::ColorMaskComponent >() { return SbkPySide6_QtGuiTypes[SBK_QRHIGRAPHICSPIPELINE_COLORMASKCOMPONENT_IDX]; }
template<> inline PyTypeObject *SbkType< ::QFlags<QRhiGraphicsPipeline::ColorMaskComponent> >() { return SbkPySide6_QtGuiTypes[SBK_QFLAGS_QRHIGRAPHICSPIPELINE_COLORMASKCOMPONENT_IDX]; }
template<> inline PyTypeObject *SbkType< ::QRhiGraphicsPipeline::BlendFactor >() { return SbkPySide6_QtGuiTypes[SBK_QRHIGRAPHICSPIPELINE_BLENDFACTOR_IDX]; }
template<> inline PyTypeObject *SbkType< ::QRhiGraphicsPipeline::BlendOp >() { return SbkPySide6_QtGuiTypes[SBK_QRHIGRAPHICSPIPELINE_BLENDOP_IDX]; }
template<> inline PyTypeObject *SbkType< ::QRhiGraphicsPipeline::CompareOp >() { return SbkPySide6_QtGuiTypes[SBK_QRHIGRAPHICSPIPELINE_COMPAREOP_IDX]; }
template<> inline PyTypeObject *SbkType< ::QRhiGraphicsPipeline::StencilOp >() { return SbkPySide6_QtGuiTypes[SBK_QRHIGRAPHICSPIPELINE_STENCILOP_IDX]; }
template<> inline PyTypeObject *SbkType< ::QRhiGraphicsPipeline::PolygonMode >() { return SbkPySide6_QtGuiTypes[SBK_QRHIGRAPHICSPIPELINE_POLYGONMODE_IDX]; }
template<> inline PyTypeObject *SbkType< ::QRhiGraphicsPipeline >() { return reinterpret_cast<PyTypeObject *>(SbkPySide6_QtGuiTypes[SBK_QRHIGRAPHICSPIPELINE_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiGraphicsPipeline::TargetBlend >() { return reinterpret_cast<PyTypeObject *>(SbkPySide6_QtGuiTypes[SBK_QRHIGRAPHICSPIPELINE_TARGETBLEND_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiInitParams >() { return reinterpret_cast<PyTypeObject *>(SbkPySide6_QtGuiTypes[SBK_QRHIINITPARAMS_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiNativeHandles >() { return reinterpret_cast<PyTypeObject *>(SbkPySide6_QtGuiTypes[SBK_QRHINATIVEHANDLES_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiNullInitParams >() { return reinterpret_cast<PyTypeObject *>(SbkPySide6_QtGuiTypes[SBK_QRHINULLINITPARAMS_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiReadbackDescription >() { return reinterpret_cast<PyTypeObject *>(SbkPySide6_QtGuiTypes[SBK_QRHIREADBACKDESCRIPTION_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiReadbackResult >() { return reinterpret_cast<PyTypeObject *>(SbkPySide6_QtGuiTypes[SBK_QRHIREADBACKRESULT_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiRenderBuffer::Type >() { return SbkPySide6_QtGuiTypes[SBK_QRHIRENDERBUFFER_TYPE_IDX]; }
template<> inline PyTypeObject *SbkType< ::QRhiRenderBuffer::Flag >() { return SbkPySide6_QtGuiTypes[SBK_QRHIRENDERBUFFER_FLAG_IDX]; }
template<> inline PyTypeObject *SbkType< ::QFlags<QRhiRenderBuffer::Flag> >() { return SbkPySide6_QtGuiTypes[SBK_QFLAGS_QRHIRENDERBUFFER_FLAG_IDX]; }
template<> inline PyTypeObject *SbkType< ::QRhiRenderBuffer >() { return reinterpret_cast<PyTypeObject *>(SbkPySide6_QtGuiTypes[SBK_QRHIRENDERBUFFER_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiRenderPassDescriptor >() { return reinterpret_cast<PyTypeObject *>(SbkPySide6_QtGuiTypes[SBK_QRHIRENDERPASSDESCRIPTOR_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiRenderTarget >() { return reinterpret_cast<PyTypeObject *>(SbkPySide6_QtGuiTypes[SBK_QRHIRENDERTARGET_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiResource::Type >() { return SbkPySide6_QtGuiTypes[SBK_QRHIRESOURCE_TYPE_IDX]; }
template<> inline PyTypeObject *SbkType< ::QRhiResource >() { return reinterpret_cast<PyTypeObject *>(SbkPySide6_QtGuiTypes[SBK_QRHIRESOURCE_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiResourceUpdateBatch >() { return reinterpret_cast<PyTypeObject *>(SbkPySide6_QtGuiTypes[SBK_QRHIRESOURCEUPDATEBATCH_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiSampler::Filter >() { return SbkPySide6_QtGuiTypes[SBK_QRHISAMPLER_FILTER_IDX]; }
template<> inline PyTypeObject *SbkType< ::QRhiSampler::AddressMode >() { return SbkPySide6_QtGuiTypes[SBK_QRHISAMPLER_ADDRESSMODE_IDX]; }
template<> inline PyTypeObject *SbkType< ::QRhiSampler::CompareOp >() { return SbkPySide6_QtGuiTypes[SBK_QRHISAMPLER_COMPAREOP_IDX]; }
template<> inline PyTypeObject *SbkType< ::QRhiSampler >() { return reinterpret_cast<PyTypeObject *>(SbkPySide6_QtGuiTypes[SBK_QRHISAMPLER_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiScissor >() { return reinterpret_cast<PyTypeObject *>(SbkPySide6_QtGuiTypes[SBK_QRHISCISSOR_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiShaderResourceBinding::Type >() { return SbkPySide6_QtGuiTypes[SBK_QRHISHADERRESOURCEBINDING_TYPE_IDX]; }
template<> inline PyTypeObject *SbkType< ::QRhiShaderResourceBinding::StageFlag >() { return SbkPySide6_QtGuiTypes[SBK_QRHISHADERRESOURCEBINDING_STAGEFLAG_IDX]; }
template<> inline PyTypeObject *SbkType< ::QFlags<QRhiShaderResourceBinding::StageFlag> >() { return SbkPySide6_QtGuiTypes[SBK_QFLAGS_QRHISHADERRESOURCEBINDING_STAGEFLAG_IDX]; }
template<> inline PyTypeObject *SbkType< ::QRhiShaderResourceBinding >() { return reinterpret_cast<PyTypeObject *>(SbkPySide6_QtGuiTypes[SBK_QRHISHADERRESOURCEBINDING_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiShaderResourceBinding::Data >() { return reinterpret_cast<PyTypeObject *>(SbkPySide6_QtGuiTypes[SBK_QRHISHADERRESOURCEBINDING_DATA_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiShaderResourceBinding::Data::StorageBufferData >() { return reinterpret_cast<PyTypeObject *>(SbkPySide6_QtGuiTypes[SBK_QRHISHADERRESOURCEBINDING_DATA_STORAGEBUFFERDATA_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiShaderResourceBinding::Data::StorageImageData >() { return reinterpret_cast<PyTypeObject *>(SbkPySide6_QtGuiTypes[SBK_QRHISHADERRESOURCEBINDING_DATA_STORAGEIMAGEDATA_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiShaderResourceBinding::TextureAndSampler >() { return reinterpret_cast<PyTypeObject *>(SbkPySide6_QtGuiTypes[SBK_QRHISHADERRESOURCEBINDING_TEXTUREANDSAMPLER_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiShaderResourceBindings::UpdateFlag >() { return SbkPySide6_QtGuiTypes[SBK_QRHISHADERRESOURCEBINDINGS_UPDATEFLAG_IDX]; }
template<> inline PyTypeObject *SbkType< ::QFlags<QRhiShaderResourceBindings::UpdateFlag> >() { return SbkPySide6_QtGuiTypes[SBK_QFLAGS_QRHISHADERRESOURCEBINDINGS_UPDATEFLAG_IDX]; }
template<> inline PyTypeObject *SbkType< ::QRhiShaderResourceBindings >() { return reinterpret_cast<PyTypeObject *>(SbkPySide6_QtGuiTypes[SBK_QRHISHADERRESOURCEBINDINGS_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiShaderStage::Type >() { return SbkPySide6_QtGuiTypes[SBK_QRHISHADERSTAGE_TYPE_IDX]; }
template<> inline PyTypeObject *SbkType< ::QRhiShaderStage >() { return reinterpret_cast<PyTypeObject *>(SbkPySide6_QtGuiTypes[SBK_QRHISHADERSTAGE_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiStats >() { return reinterpret_cast<PyTypeObject *>(SbkPySide6_QtGuiTypes[SBK_QRHISTATS_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiSwapChain::Flag >() { return SbkPySide6_QtGuiTypes[SBK_QRHISWAPCHAIN_FLAG_IDX]; }
template<> inline PyTypeObject *SbkType< ::QFlags<QRhiSwapChain::Flag> >() { return SbkPySide6_QtGuiTypes[SBK_QFLAGS_QRHISWAPCHAIN_FLAG_IDX]; }
template<> inline PyTypeObject *SbkType< ::QRhiSwapChain::Format >() { return SbkPySide6_QtGuiTypes[SBK_QRHISWAPCHAIN_FORMAT_IDX]; }
template<> inline PyTypeObject *SbkType< ::QRhiSwapChain::StereoTargetBuffer >() { return SbkPySide6_QtGuiTypes[SBK_QRHISWAPCHAIN_STEREOTARGETBUFFER_IDX]; }
template<> inline PyTypeObject *SbkType< ::QRhiSwapChain >() { return reinterpret_cast<PyTypeObject *>(SbkPySide6_QtGuiTypes[SBK_QRHISWAPCHAIN_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiSwapChainRenderTarget >() { return reinterpret_cast<PyTypeObject *>(SbkPySide6_QtGuiTypes[SBK_QRHISWAPCHAINRENDERTARGET_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiTexture::Flag >() { return SbkPySide6_QtGuiTypes[SBK_QRHITEXTURE_FLAG_IDX]; }
template<> inline PyTypeObject *SbkType< ::QFlags<QRhiTexture::Flag> >() { return SbkPySide6_QtGuiTypes[SBK_QFLAGS_QRHITEXTURE_FLAG_IDX]; }
template<> inline PyTypeObject *SbkType< ::QRhiTexture::Format >() { return SbkPySide6_QtGuiTypes[SBK_QRHITEXTURE_FORMAT_IDX]; }
template<> inline PyTypeObject *SbkType< ::QRhiTexture >() { return reinterpret_cast<PyTypeObject *>(SbkPySide6_QtGuiTypes[SBK_QRHITEXTURE_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiTextureCopyDescription >() { return reinterpret_cast<PyTypeObject *>(SbkPySide6_QtGuiTypes[SBK_QRHITEXTURECOPYDESCRIPTION_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiTextureRenderTarget::Flag >() { return SbkPySide6_QtGuiTypes[SBK_QRHITEXTURERENDERTARGET_FLAG_IDX]; }
template<> inline PyTypeObject *SbkType< ::QFlags<QRhiTextureRenderTarget::Flag> >() { return SbkPySide6_QtGuiTypes[SBK_QFLAGS_QRHITEXTURERENDERTARGET_FLAG_IDX]; }
template<> inline PyTypeObject *SbkType< ::QRhiTextureRenderTarget >() { return reinterpret_cast<PyTypeObject *>(SbkPySide6_QtGuiTypes[SBK_QRHITEXTURERENDERTARGET_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiTextureRenderTargetDescription >() { return reinterpret_cast<PyTypeObject *>(SbkPySide6_QtGuiTypes[SBK_QRHITEXTURERENDERTARGETDESCRIPTION_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiTextureSubresourceUploadDescription >() { return reinterpret_cast<PyTypeObject *>(SbkPySide6_QtGuiTypes[SBK_QRHITEXTURESUBRESOURCEUPLOADDESCRIPTION_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiTextureUploadDescription >() { return reinterpret_cast<PyTypeObject *>(SbkPySide6_QtGuiTypes[SBK_QRHITEXTUREUPLOADDESCRIPTION_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiTextureUploadEntry >() { return reinterpret_cast<PyTypeObject *>(SbkPySide6_QtGuiTypes[SBK_QRHITEXTUREUPLOADENTRY_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiVertexInputAttribute::Format >() { return SbkPySide6_QtGuiTypes[SBK_QRHIVERTEXINPUTATTRIBUTE_FORMAT_IDX]; }
template<> inline PyTypeObject *SbkType< ::QRhiVertexInputAttribute >() { return reinterpret_cast<PyTypeObject *>(SbkPySide6_QtGuiTypes[SBK_QRHIVERTEXINPUTATTRIBUTE_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiVertexInputBinding::Classification >() { return SbkPySide6_QtGuiTypes[SBK_QRHIVERTEXINPUTBINDING_CLASSIFICATION_IDX]; }
template<> inline PyTypeObject *SbkType< ::QRhiVertexInputBinding >() { return reinterpret_cast<PyTypeObject *>(SbkPySide6_QtGuiTypes[SBK_QRHIVERTEXINPUTBINDING_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiVertexInputLayout >() { return reinterpret_cast<PyTypeObject *>(SbkPySide6_QtGuiTypes[SBK_QRHIVERTEXINPUTLAYOUT_IDX]); }
template<> inline PyTypeObject *SbkType< ::QRhiViewport >() { return reinterpret_cast<PyTypeObject *>(SbkPySide6_QtGuiTypes[SBK_QRHIVIEWPORT_IDX]); }
template<> inline PyTypeObject *SbkType< ::QShader::Stage >() { return SbkPySide6_QtGuiTypes[SBK_QSHADER_STAGE_IDX]; }
template<> inline PyTypeObject *SbkType< ::QShader::Source >() { return SbkPySide6_QtGuiTypes[SBK_QSHADER_SOURCE_IDX]; }
template<> inline PyTypeObject *SbkType< ::QShader::Variant >() { return SbkPySide6_QtGuiTypes[SBK_QSHADER_VARIANT_IDX]; }
template<> inline PyTypeObject *SbkType< ::QShader::SerializedFormatVersion >() { return SbkPySide6_QtGuiTypes[SBK_QSHADER_SERIALIZEDFORMATVERSION_IDX]; }
template<> inline PyTypeObject *SbkType< ::QShader >() { return reinterpret_cast<PyTypeObject *>(SbkPySide6_QtGuiTypes[SBK_QSHADER_IDX]); }
template<> inline PyTypeObject *SbkType< ::QShaderCode >() { return reinterpret_cast<PyTypeObject *>(SbkPySide6_QtGuiTypes[SBK_QSHADERCODE_IDX]); }
template<> inline PyTypeObject *SbkType< ::QShaderKey >() { return reinterpret_cast<PyTypeObject *>(SbkPySide6_QtGuiTypes[SBK_QSHADERKEY_IDX]); }
template<> inline PyTypeObject *SbkType< ::QShaderVersion::Flag >() { return SbkPySide6_QtGuiTypes[SBK_QSHADERVERSION_FLAG_IDX]; }
template<> inline PyTypeObject *SbkType< ::QFlags<QShaderVersion::Flag> >() { return SbkPySide6_QtGuiTypes[SBK_QFLAGS_QSHADERVERSION_FLAG_IDX]; }
template<> inline PyTypeObject *SbkType< ::QShaderVersion >() { return reinterpret_cast<PyTypeObject *>(SbkPySide6_QtGuiTypes[SBK_QSHADERVERSION_IDX]); }

} // namespace Shiboken

QT_WARNING_POP
#endif
