// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QRHICOMMANDBUFFERWRAPPER_H
#define SBK_QRHICOMMANDBUFFERWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <rhi/qrhi.h>

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QRhiCommandBufferWrapper : public QRhiCommandBuffer
{
public:
    QRhiCommandBufferWrapper(const QRhiCommandBufferWrapper &) = delete;
    QRhiCommandBufferWrapper& operator=(const QRhiCommandBufferWrapper &) = delete;
    QRhiCommandBufferWrapper(QRhiCommandBufferWrapper &&) = delete;
    QRhiCommandBufferWrapper& operator=(QRhiCommandBufferWrapper &&) = delete;

    void destroy() override;
    ::QRhiResource::Type resourceType() const override;
    ~QRhiCommandBufferWrapper() override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[2];
};

#endif // SBK_QRHICOMMANDBUFFERWRAPPER_H

