// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtscxml_python.h"

// main header
#include "qscxmlexecutablecontent_wrapper.h"

// inner classes
#include "qscxmlexecutablecontent_invokeinfo_wrapper.h"
#include "qscxmlexecutablecontent_parameterinfo_wrapper.h"
#include "qscxmlexecutablecontent_foreachinfo_wrapper.h"
#include "qscxmlexecutablecontent_assignmentinfo_wrapper.h"
#include "qscxmlexecutablecontent_evaluatorinfo_wrapper.h"

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {

static const char *Sbk_QScxmlExecutableContent_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QScxmlExecutableContent_methods[] = {
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QScxmlExecutableContent_traverse(PyObject *self, visitproc visit, void *arg)
{
    return SbkObject_TypeF()->tp_traverse(self, visit, arg);
}
static int Sbk_QScxmlExecutableContent_clear(PyObject *self)
{
    return reinterpret_cast<PyTypeObject *>(SbkObject_TypeF())->tp_clear(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QScxmlExecutableContent_Type = nullptr;
static PyTypeObject *Sbk_QScxmlExecutableContent_TypeF(void)
{
    return _Sbk_QScxmlExecutableContent_Type;
}

static PyType_Slot Sbk_QScxmlExecutableContent_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(Sbk_object_dealloc /* PYSIDE-832: Prevent replacement of "0" with subtype_dealloc. */)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QScxmlExecutableContent_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QScxmlExecutableContent_clear)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QScxmlExecutableContent_methods)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QScxmlExecutableContent_spec = {
    "2:PySide6.QtScxml.QScxmlExecutableContent",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QScxmlExecutableContent_slots
};

} //extern "C"

// Type conversion functions.

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QtScxmlQScxmlExecutableContent_SignatureStrings[] = {
    nullptr}; // Sentinel

void init_QtScxmlQScxmlExecutableContent(PyObject *module)
{
    _Sbk_QScxmlExecutableContent_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QScxmlExecutableContent",
        "QScxmlExecutableContent",
        &Sbk_QScxmlExecutableContent_spec,
        nullptr,
        nullptr,
        0,
        0);
    auto *pyType = Sbk_QScxmlExecutableContent_TypeF(); // references _Sbk_QScxmlExecutableContent_Type
    InitSignatureStrings(pyType, QtScxmlQScxmlExecutableContent_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QScxmlExecutableContent_PropertyStrings);
    SbkPySide6_QtScxmlTypes[SBK_QtScxmlQSCXMLEXECUTABLECONTENT_IDX] = pyType;


}
