// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
#ifndef SBK_QWEBENGINECOOKIESTOREWRAPPER_H
#define SBK_QWEBENGINECOOKIESTOREWRAPPER_H

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

#include <QtWebEngineCore/qwebenginecookiestore.h>

namespace PySide { class DynamicQMetaObject; }

// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only
class QWebEngineCookieStoreWrapper : public QWebEngineCookieStore
{
public:
    QWebEngineCookieStoreWrapper(const QWebEngineCookieStoreWrapper &) = delete;
    QWebEngineCookieStoreWrapper& operator=(const QWebEngineCookieStoreWrapper &) = delete;
    QWebEngineCookieStoreWrapper(QWebEngineCookieStoreWrapper &&) = delete;
    QWebEngineCookieStoreWrapper& operator=(QWebEngineCookieStoreWrapper &&) = delete;

    void childEvent(::QChildEvent * event) override;
    void connectNotify(const ::QMetaMethod & signal) override;
    void customEvent(::QEvent * event) override;
    void disconnectNotify(const ::QMetaMethod & signal) override;
    bool event(::QEvent * event) override;
    bool eventFilter(::QObject * watched, ::QEvent * event) override;
    const ::QMetaObject * metaObject() const override;
    void timerEvent(::QTimerEvent * event) override;
    ~QWebEngineCookieStoreWrapper() override;
public:
    int qt_metacall(QMetaObject::Call call, int id, void **args) override;
    void *qt_metacast(const char *_clname) override;
    static void pysideInitQtMetaTypes();
    void resetPyMethodCache();
private:
    mutable bool m_PyMethodCache[7];
};

#endif // SBK_QWEBENGINECOOKIESTOREWRAPPER_H

