// Copyright (C) 2022 The Qt Company Ltd.
// SPDX-License-Identifier: LicenseRef-Qt-Commercial OR LGPL-3.0-only OR GPL-2.0-only OR GPL-3.0-only

// Workaround to access protected functions
#ifndef protected
#  define protected public
#endif

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QtCore/QDebug>
#include <pysideqenum.h>
#include <pysideqmetatype.h>
#include <pysideutils.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED


// module include
#include "pyside6_qtwebenginecore_python.h"

// main header
#include "qwebenginefilesystemaccessrequest_wrapper.h"

// Argument includes
#include <QtWebEngineCore/qwebenginefilesystemaccessrequest.h>
#include <qobject.h>
#include <qobjectdefs.h>
#include <qurl.h>

#include <cctype>
#include <cstring>
#include <iterator>
#include <typeinfo>


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QWebEngineFileSystemAccessRequest_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SBK_UNUSED(kwds)
    auto *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QWebEngineFileSystemAccessRequest >()))
        return -1;

    ::QWebEngineFileSystemAccessRequest *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char fullName[] = "PySide6.QtWebEngineCore.QWebEngineFileSystemAccessRequest.__init__";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {nullptr};

    // invalid argument lengths

    if (PyArg_UnpackTuple(args, "QWebEngineFileSystemAccessRequest", 1, 1, &(pyArgs[0])) == 0)
        return -1;


    // Overloaded function decisor
    // 0: QWebEngineFileSystemAccessRequest::QWebEngineFileSystemAccessRequest(QWebEngineFileSystemAccessRequest)
    if (numArgs == 1
        && (pyArgs[0] != Py_None && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppPointerConversion(SbkPySide6_QtWebEngineCoreTypes[SBK_QWEBENGINEFILESYSTEMACCESSREQUEST_IDX], (pyArgs[0]))))) {
        overloadId = 0; // QWebEngineFileSystemAccessRequest(QWebEngineFileSystemAccessRequest)
    }

    // Function signature not found.
    if (overloadId == -1)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);


    // PyMI support
    Shiboken::callInheritedInit(self, args, kwds, fullName);
    if (Shiboken::Errors::occurred() != nullptr)
        return -1;

    // Call function/method
    {
        if (!Shiboken::Object::isValid(pyArgs[0]))
            return -1;
        ::QWebEngineFileSystemAccessRequest *cppArg0;
        pythonToCpp[0](pyArgs[0], &cppArg0);

        if (Shiboken::Errors::occurred() == nullptr) {
            // QWebEngineFileSystemAccessRequest(QWebEngineFileSystemAccessRequest)
            cptr = new ::QWebEngineFileSystemAccessRequest(*cppArg0);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QWebEngineFileSystemAccessRequest >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (cptr == nullptr)
        return Shiboken::returnWrongArguments_MinusOne(args, fullName, errInfo);

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;
}

static PyObject *Sbk_QWebEngineFileSystemAccessRequestFunc_accept(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineFileSystemAccessRequest *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtWebEngineCoreTypes[SBK_QWEBENGINEFILESYSTEMACCESSREQUEST_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    static const char fullName[] = "PySide6.QtWebEngineCore.QWebEngineFileSystemAccessRequest.accept";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // accept()
            cppSelf->accept();
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QWebEngineFileSystemAccessRequestFunc_accessFlags(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineFileSystemAccessRequest *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtWebEngineCoreTypes[SBK_QWEBENGINEFILESYSTEMACCESSREQUEST_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtWebEngineCore.QWebEngineFileSystemAccessRequest.accessFlags";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // accessFlags()const
            QFlags<QWebEngineFileSystemAccessRequest::AccessFlag> cppResult = const_cast<const ::QWebEngineFileSystemAccessRequest *>(cppSelf)->accessFlags();
            pyResult = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(SbkPySide6_QtWebEngineCoreTypes[SBK_QFLAGS_QWEBENGINEFILESYSTEMACCESSREQUEST_ACCESSFLAG_IDX]))->converter, &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QWebEngineFileSystemAccessRequestFunc_filePath(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineFileSystemAccessRequest *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtWebEngineCoreTypes[SBK_QWEBENGINEFILESYSTEMACCESSREQUEST_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtWebEngineCore.QWebEngineFileSystemAccessRequest.filePath";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // filePath()const
            QUrl cppResult = const_cast<const ::QWebEngineFileSystemAccessRequest *>(cppSelf)->filePath();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypes[SBK_QURL_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QWebEngineFileSystemAccessRequestFunc_handleType(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineFileSystemAccessRequest *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtWebEngineCoreTypes[SBK_QWEBENGINEFILESYSTEMACCESSREQUEST_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtWebEngineCore.QWebEngineFileSystemAccessRequest.handleType";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // handleType()const
            QWebEngineFileSystemAccessRequest::HandleType cppResult = const_cast<const ::QWebEngineFileSystemAccessRequest *>(cppSelf)->handleType();
            pyResult = Shiboken::Conversions::copyToPython(PepType_SETP(reinterpret_cast<SbkEnumType *>(SbkPySide6_QtWebEngineCoreTypes[SBK_QWEBENGINEFILESYSTEMACCESSREQUEST_HANDLETYPE_IDX]))->converter, &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QWebEngineFileSystemAccessRequestFunc_origin(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineFileSystemAccessRequest *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtWebEngineCoreTypes[SBK_QWEBENGINEFILESYSTEMACCESSREQUEST_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    static const char fullName[] = "PySide6.QtWebEngineCore.QWebEngineFileSystemAccessRequest.origin";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // origin()const
            QUrl cppResult = const_cast<const ::QWebEngineFileSystemAccessRequest *>(cppSelf)->origin();
            pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtCoreTypes[SBK_QURL_IDX], &cppResult);
        }
    }

    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}

static PyObject *Sbk_QWebEngineFileSystemAccessRequestFunc_reject(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto *cppSelf = reinterpret_cast< ::QWebEngineFileSystemAccessRequest *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtWebEngineCoreTypes[SBK_QWEBENGINEFILESYSTEMACCESSREQUEST_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    static const char fullName[] = "PySide6.QtWebEngineCore.QWebEngineFileSystemAccessRequest.reject";
    SBK_UNUSED(fullName)
    Shiboken::PythonContextMarker pcm;

    // Call function/method
    {

        if (Shiboken::Errors::occurred() == nullptr) {
            // reject()
            cppSelf->reject();
        }
    }

    if (Shiboken::Errors::occurred() != nullptr) {
        return {};
    }
    Py_RETURN_NONE;
}

static PyObject *Sbk_QWebEngineFileSystemAccessRequest__copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QWebEngineFileSystemAccessRequest *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtWebEngineCoreTypes[SBK_QWEBENGINEFILESYSTEMACCESSREQUEST_IDX], reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtWebEngineCoreTypes[SBK_QWEBENGINEFILESYSTEMACCESSREQUEST_IDX], &cppSelf);
    if (Shiboken::Errors::occurred() != nullptr || pyResult == nullptr) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QWebEngineFileSystemAccessRequest_PropertyStrings[] = {
    "accessFlags:",
    "filePath:",
    "handleType:",
    "origin:",
    nullptr // Sentinel
};

static const char *Sbk_QWebEngineFileSystemAccessRequest_EnumFlagInfo[] = {
    "AccessFlag:Flag:AccessFlags",
    "HandleType:Enum",
    nullptr // Sentinel
};

static PyMethodDef Sbk_QWebEngineFileSystemAccessRequest_methods[] = {
    {"accept", reinterpret_cast<PyCFunction>(Sbk_QWebEngineFileSystemAccessRequestFunc_accept), METH_NOARGS, nullptr},
    {"accessFlags", reinterpret_cast<PyCFunction>(Sbk_QWebEngineFileSystemAccessRequestFunc_accessFlags), METH_NOARGS, nullptr},
    {"filePath", reinterpret_cast<PyCFunction>(Sbk_QWebEngineFileSystemAccessRequestFunc_filePath), METH_NOARGS, nullptr},
    {"handleType", reinterpret_cast<PyCFunction>(Sbk_QWebEngineFileSystemAccessRequestFunc_handleType), METH_NOARGS, nullptr},
    {"origin", reinterpret_cast<PyCFunction>(Sbk_QWebEngineFileSystemAccessRequestFunc_origin), METH_NOARGS, nullptr},
    {"reject", reinterpret_cast<PyCFunction>(Sbk_QWebEngineFileSystemAccessRequestFunc_reject), METH_NOARGS, nullptr},
    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QWebEngineFileSystemAccessRequest__copy__), METH_NOARGS, nullptr},
    {nullptr, nullptr, 0, nullptr} // Sentinel
};

// Rich comparison
static PyObject * Sbk_QWebEngineFileSystemAccessRequest_richcompare(PyObject *self, PyObject *pyArg, int op)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QWebEngineFileSystemAccessRequest *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtWebEngineCoreTypes[SBK_QWEBENGINEFILESYSTEMACCESSREQUEST_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyResult{};
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    SBK_UNUSED(pythonToCpp)

    switch (op) {
        case Py_NE:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppPointerConversion(SbkPySide6_QtWebEngineCoreTypes[SBK_QWEBENGINEFILESYSTEMACCESSREQUEST_IDX], (pyArg)))) {
                // operator!=(const QWebEngineFileSystemAccessRequest & rhs)
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QWebEngineFileSystemAccessRequest *cppArg0;
                pythonToCpp(pyArg, &cppArg0);
                bool cppResult = cppSelf != (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_True;
                Py_INCREF(pyResult);
            }

            break;
        case Py_EQ:
            if ((pythonToCpp = Shiboken::Conversions::pythonToCppPointerConversion(SbkPySide6_QtWebEngineCoreTypes[SBK_QWEBENGINEFILESYSTEMACCESSREQUEST_IDX], (pyArg)))) {
                // operator==(const QWebEngineFileSystemAccessRequest & rhs)
                if (!Shiboken::Object::isValid(pyArg))
                    return {};
                ::QWebEngineFileSystemAccessRequest *cppArg0;
                pythonToCpp(pyArg, &cppArg0);
                bool cppResult = cppSelf == (*cppArg0);
                pyResult = Shiboken::Conversions::copyToPython(Shiboken::Conversions::PrimitiveTypeConverter<bool>(), &cppResult);
            } else {
                pyResult = Py_False;
                Py_INCREF(pyResult);
            }

            break;
        default:
            // PYSIDE-74: By default, we redirect to object's tp_richcompare (which is `==`, `!=`).
            return FallbackRichCompare(self, pyArg, op);
    }

    return Shiboken::returnFromRichCompare(pyResult);
}

} // extern "C"

static int Sbk_QWebEngineFileSystemAccessRequest_traverse(PyObject *self, visitproc visit, void *arg)
{
    return SbkObject_TypeF()->tp_traverse(self, visit, arg);
}
static int Sbk_QWebEngineFileSystemAccessRequest_clear(PyObject *self)
{
    return reinterpret_cast<PyTypeObject *>(SbkObject_TypeF())->tp_clear(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QWebEngineFileSystemAccessRequest_Type = nullptr;
static PyTypeObject *Sbk_QWebEngineFileSystemAccessRequest_TypeF(void)
{
    return _Sbk_QWebEngineFileSystemAccessRequest_Type;
}

static PyType_Slot Sbk_QWebEngineFileSystemAccessRequest_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QWebEngineFileSystemAccessRequest_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QWebEngineFileSystemAccessRequest_clear)},
    {Py_tp_richcompare, reinterpret_cast<void *>(Sbk_QWebEngineFileSystemAccessRequest_richcompare)},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QWebEngineFileSystemAccessRequest_methods)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QWebEngineFileSystemAccessRequest_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObject_tp_new)},
    {0, nullptr}
};
static PyType_Spec Sbk_QWebEngineFileSystemAccessRequest_spec = {
    "2:PySide6.QtWebEngineCore.QWebEngineFileSystemAccessRequest",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QWebEngineFileSystemAccessRequest_slots
};

} //extern "C"

// Type conversion functions.

// Python to C++ enum conversion.
static void QWebEngineFileSystemAccessRequest_HandleType_PythonToCpp_QWebEngineFileSystemAccessRequest_HandleType(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QWebEngineFileSystemAccessRequest::HandleType>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QWebEngineFileSystemAccessRequest::HandleType *>(cppOut) = value;

}
static PythonToCppFunc is_QWebEngineFileSystemAccessRequest_HandleType_PythonToCpp_QWebEngineFileSystemAccessRequest_HandleType_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, SbkPySide6_QtWebEngineCoreTypes[SBK_QWEBENGINEFILESYSTEMACCESSREQUEST_HANDLETYPE_IDX]))
        return QWebEngineFileSystemAccessRequest_HandleType_PythonToCpp_QWebEngineFileSystemAccessRequest_HandleType;
    return {};
}
static PyObject *QWebEngineFileSystemAccessRequest_HandleType_CppToPython_QWebEngineFileSystemAccessRequest_HandleType(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QWebEngineFileSystemAccessRequest::HandleType *>(cppIn));
    return Shiboken::Enum::newItem(SbkPySide6_QtWebEngineCoreTypes[SBK_QWEBENGINEFILESYSTEMACCESSREQUEST_HANDLETYPE_IDX], castCppIn);

}

static void QWebEngineFileSystemAccessRequest_AccessFlag_PythonToCpp_QWebEngineFileSystemAccessRequest_AccessFlag(PyObject *pyIn, void *cppOut)
{
    const auto value = static_cast<::QWebEngineFileSystemAccessRequest::AccessFlag>(Shiboken::Enum::getValue(pyIn));
    *reinterpret_cast<::QWebEngineFileSystemAccessRequest::AccessFlag *>(cppOut) = value;

}
static PythonToCppFunc is_QWebEngineFileSystemAccessRequest_AccessFlag_PythonToCpp_QWebEngineFileSystemAccessRequest_AccessFlag_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, SbkPySide6_QtWebEngineCoreTypes[SBK_QWEBENGINEFILESYSTEMACCESSREQUEST_ACCESSFLAG_IDX]))
        return QWebEngineFileSystemAccessRequest_AccessFlag_PythonToCpp_QWebEngineFileSystemAccessRequest_AccessFlag;
    return {};
}
static PyObject *QWebEngineFileSystemAccessRequest_AccessFlag_CppToPython_QWebEngineFileSystemAccessRequest_AccessFlag(const void *cppIn)
{
    const int castCppIn = int(*reinterpret_cast<const ::QWebEngineFileSystemAccessRequest::AccessFlag *>(cppIn));
    return Shiboken::Enum::newItem(SbkPySide6_QtWebEngineCoreTypes[SBK_QWEBENGINEFILESYSTEMACCESSREQUEST_ACCESSFLAG_IDX], castCppIn);

}

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void QWebEngineFileSystemAccessRequest_PythonToCpp_QWebEngineFileSystemAccessRequest_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QWebEngineFileSystemAccessRequest_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_QWebEngineFileSystemAccessRequest_PythonToCpp_QWebEngineFileSystemAccessRequest_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, Sbk_QWebEngineFileSystemAccessRequest_TypeF()))
        return QWebEngineFileSystemAccessRequest_PythonToCpp_QWebEngineFileSystemAccessRequest_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *QWebEngineFileSystemAccessRequest_PTR_CppToPython_QWebEngineFileSystemAccessRequest(const void *cppIn)
{
    auto *pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool changedTypeName = false;
    auto *tCppIn = reinterpret_cast<const ::QWebEngineFileSystemAccessRequest *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto *sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType != nullptr && Shiboken::ObjectType::hasSpecialCastFunction(sbkType)) {
        typeName = Shiboken::typeNameOf(typeid(*tCppIn).name());
        changedTypeName = true;
    }
    PyObject *result = Shiboken::Object::newObject(Sbk_QWebEngineFileSystemAccessRequest_TypeF(), const_cast<void *>(cppIn), false, /* exactType */ changedTypeName, typeName);
    if (changedTypeName)
        delete [] typeName;
    return result;
}

// C++ to Python copy conversion.
static PyObject *QWebEngineFileSystemAccessRequest_COPY_CppToPython_QWebEngineFileSystemAccessRequest(const void *cppIn)
{
    auto *source = reinterpret_cast<const ::QWebEngineFileSystemAccessRequest *>(cppIn);
    return Shiboken::Object::newObject(Sbk_QWebEngineFileSystemAccessRequest_TypeF(), new ::QWebEngineFileSystemAccessRequest(*source), true, true);
}

// Python to C++ copy conversion.
static void QWebEngineFileSystemAccessRequest_PythonToCpp_QWebEngineFileSystemAccessRequest_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QWebEngineFileSystemAccessRequest *>(cppOut) = *reinterpret_cast< ::QWebEngineFileSystemAccessRequest *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtWebEngineCoreTypes[SBK_QWEBENGINEFILESYSTEMACCESSREQUEST_IDX], reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_QWebEngineFileSystemAccessRequest_PythonToCpp_QWebEngineFileSystemAccessRequest_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, Sbk_QWebEngineFileSystemAccessRequest_TypeF()))
        return QWebEngineFileSystemAccessRequest_PythonToCpp_QWebEngineFileSystemAccessRequest_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QWebEngineFileSystemAccessRequest_SignatureStrings[] = {
    "PySide6.QtWebEngineCore.QWebEngineFileSystemAccessRequest(self,other:PySide6.QtWebEngineCore.QWebEngineFileSystemAccessRequest)",
    "PySide6.QtWebEngineCore.QWebEngineFileSystemAccessRequest.accept(self)",
    "PySide6.QtWebEngineCore.QWebEngineFileSystemAccessRequest.accessFlags(self)->PySide6.QtWebEngineCore.QWebEngineFileSystemAccessRequest.AccessFlag",
    "PySide6.QtWebEngineCore.QWebEngineFileSystemAccessRequest.filePath(self)->PySide6.QtCore.QUrl",
    "PySide6.QtWebEngineCore.QWebEngineFileSystemAccessRequest.handleType(self)->PySide6.QtWebEngineCore.QWebEngineFileSystemAccessRequest.HandleType",
    "PySide6.QtWebEngineCore.QWebEngineFileSystemAccessRequest.origin(self)->PySide6.QtCore.QUrl",
    "PySide6.QtWebEngineCore.QWebEngineFileSystemAccessRequest.reject(self)",
    "PySide6.QtWebEngineCore.QWebEngineFileSystemAccessRequest.__copy__()",
    nullptr}; // Sentinel

void init_QWebEngineFileSystemAccessRequest(PyObject *module)
{
    _Sbk_QWebEngineFileSystemAccessRequest_Type = Shiboken::ObjectType::introduceWrapperType(
        module,
        "QWebEngineFileSystemAccessRequest",
        "QWebEngineFileSystemAccessRequest",
        &Sbk_QWebEngineFileSystemAccessRequest_spec,
        &Shiboken::callCppDestructor< ::QWebEngineFileSystemAccessRequest >,
        nullptr,
        0,
        0);
    auto *pyType = Sbk_QWebEngineFileSystemAccessRequest_TypeF(); // references _Sbk_QWebEngineFileSystemAccessRequest_Type
    InitSignatureStrings(pyType, QWebEngineFileSystemAccessRequest_SignatureStrings);
    SbkObjectType_SetPropertyStrings(pyType, Sbk_QWebEngineFileSystemAccessRequest_PropertyStrings);
    SbkPySide6_QtWebEngineCoreTypes[SBK_QWEBENGINEFILESYSTEMACCESSREQUEST_IDX] = pyType;

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(pyType,
        QWebEngineFileSystemAccessRequest_PythonToCpp_QWebEngineFileSystemAccessRequest_PTR,
        is_QWebEngineFileSystemAccessRequest_PythonToCpp_QWebEngineFileSystemAccessRequest_PTR_Convertible,
        QWebEngineFileSystemAccessRequest_PTR_CppToPython_QWebEngineFileSystemAccessRequest,
        QWebEngineFileSystemAccessRequest_COPY_CppToPython_QWebEngineFileSystemAccessRequest);

    Shiboken::Conversions::registerConverterName(converter, "QWebEngineFileSystemAccessRequest");
    Shiboken::Conversions::registerConverterName(converter, "QWebEngineFileSystemAccessRequest*");
    Shiboken::Conversions::registerConverterName(converter, "QWebEngineFileSystemAccessRequest&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QWebEngineFileSystemAccessRequest).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        QWebEngineFileSystemAccessRequest_PythonToCpp_QWebEngineFileSystemAccessRequest_COPY,
        is_QWebEngineFileSystemAccessRequest_PythonToCpp_QWebEngineFileSystemAccessRequest_COPY_Convertible);

    // Pass the ..._EnumFlagInfo to the class.
    SbkObjectType_SetEnumFlagInfo(pyType, Sbk_QWebEngineFileSystemAccessRequest_EnumFlagInfo);

    // Initialization of enums.
    Shiboken::AutoDecRef tpDict{};
    PyTypeObject *EType{};

    // Initialization of enum 'HandleType'.
    const char *HandleType_Initializer[] = {
        "File",
        "Directory",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t HandleType_InitializerValues[] = {
        uint8_t(QWebEngineFileSystemAccessRequest::HandleType::File),     //  0x00  0
        uint8_t(QWebEngineFileSystemAccessRequest::HandleType::Directory) //  0x01  1
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QWebEngineFileSystemAccessRequest_TypeF(),
        "2:PySide6.QtWebEngineCore.QWebEngineFileSystemAccessRequest.HandleType",
        HandleType_Initializer, HandleType_InitializerValues);
    SbkPySide6_QtWebEngineCoreTypes[SBK_QWEBENGINEFILESYSTEMACCESSREQUEST_HANDLETYPE_IDX] = EType;
    // Register converter for enum 'QWebEngineFileSystemAccessRequest::HandleType'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QWebEngineFileSystemAccessRequest_HandleType_CppToPython_QWebEngineFileSystemAccessRequest_HandleType);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QWebEngineFileSystemAccessRequest_HandleType_PythonToCpp_QWebEngineFileSystemAccessRequest_HandleType,
            is_QWebEngineFileSystemAccessRequest_HandleType_PythonToCpp_QWebEngineFileSystemAccessRequest_HandleType_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QWebEngineFileSystemAccessRequest::HandleType");
        Shiboken::Conversions::registerConverterName(converter, "HandleType");
    }
    // End of 'HandleType' enum.

    // Initialization of enum 'AccessFlag'.
    const char *AccessFlag_Initializer[] = {
        "Read",
        "Write",
        nullptr};
    // "uint8_t" used instead of "unsigned int"
    constexpr uint8_t AccessFlag_InitializerValues[] = {
        uint8_t(QWebEngineFileSystemAccessRequest::AccessFlag::Read), //  0x01  1
        uint8_t(QWebEngineFileSystemAccessRequest::AccessFlag::Write) //  0x02  2
        };
    EType = Shiboken::Enum::createPythonEnum(Sbk_QWebEngineFileSystemAccessRequest_TypeF(),
        "2:PySide6.QtWebEngineCore.QWebEngineFileSystemAccessRequest.AccessFlag",
        AccessFlag_Initializer, AccessFlag_InitializerValues);
    SbkPySide6_QtWebEngineCoreTypes[SBK_QWEBENGINEFILESYSTEMACCESSREQUEST_ACCESSFLAG_IDX] = EType;
    // PYSIDE-1735: Mapping the flags class to the same enum class.
    SbkPySide6_QtWebEngineCoreTypes[SBK_QFLAGS_QWEBENGINEFILESYSTEMACCESSREQUEST_ACCESSFLAG_IDX] =
        EType;
    // Register converter for enum 'QWebEngineFileSystemAccessRequest::AccessFlag'.
    {
        SbkConverter *converter = Shiboken::Conversions::createConverter(EType,
            QWebEngineFileSystemAccessRequest_AccessFlag_CppToPython_QWebEngineFileSystemAccessRequest_AccessFlag);
        Shiboken::Conversions::addPythonToCppValueConversion(converter,
            QWebEngineFileSystemAccessRequest_AccessFlag_PythonToCpp_QWebEngineFileSystemAccessRequest_AccessFlag,
            is_QWebEngineFileSystemAccessRequest_AccessFlag_PythonToCpp_QWebEngineFileSystemAccessRequest_AccessFlag_Convertible);
        Shiboken::Enum::setTypeConverter(EType, converter);
        Shiboken::Conversions::registerConverterName(converter, "QWebEngineFileSystemAccessRequest::AccessFlag");
        Shiboken::Conversions::registerConverterName(converter, "AccessFlag");
        // Register converter for flag 'QFlags<QWebEngineFileSystemAccessRequest::AccessFlag>'.
        Shiboken::Conversions::registerConverterName(converter, "QFlags<QWebEngineFileSystemAccessRequest::AccessFlag>");
    }
    // End of 'AccessFlag' enum/flags.

    qRegisterMetaType< ::QWebEngineFileSystemAccessRequest >("QWebEngineFileSystemAccessRequest");
    qRegisterMetaType< ::QWebEngineFileSystemAccessRequest::HandleType >("QWebEngineFileSystemAccessRequest::HandleType");
    qRegisterMetaType< ::QWebEngineFileSystemAccessRequest::AccessFlag >("QWebEngineFileSystemAccessRequest::AccessFlag");
}
